func int printFlow(int flag, string fname, mesh Th, int nt) {

   real A0 = int2d(Th)(1.0);
   real cmx= int2d(Th)(x);
   cmx = cmx/A0;
   real cmy= int2d(Th)(y);
   cmy = cmy/A0;

   if(flag!=0) { 
      ofstream ff(fname,append);  //append outputs values on the nodes 
      for(int i=0;i<nt;i++) 
      { 
         for (int j=0; j <3; j++) {
            ff<<Th[i][j].x << " "<< Th[i][j].y << " "<<u[][Vh(i,j)];
            ff<<" " << v[][Vh(i,j)];
            ff<< " " << p[][Vh(i,j)] ;
            ff<< " " << ca[][Vh(i,j)] << " " << cb[][Vh(i,j)]<< 
            " " << source[][Vh(i,j)] << " " << cmx << " " << cmy << endl; 
         }
      } 
      ff<<endl;
   } else {
      ofstream ff(fname);  //outputs values on the nodes 
      for(int i=0;i<nt;i++) 
      { 
         for (int j=0; j <3; j++) {
            ff<<Th[i][j].x << " "<< Th[i][j].y<< " "<<u[][Vh(i,j)];
            ff<<" " << v[][Vh(i,j)];
            ff<< " " << p[][Vh(i,j)] ;
            ff<< " " << ca[][Vh(i,j)] << " " << cb[][Vh(i,j)]<< 
            " " << source[][Vh(i,j)] << " " << cmx << " " << cmy << endl; 
         }
      } 
      ff<<endl;
   }
}


func int printBoundary(string fname, mesh Th) {

   int nBoundaryElements=0;
   int1d(Th,qfe=qf1pE)(1.*(nBoundaryElements++));

   real[int] xarr(nBoundaryElements);
   real[int] yarr(nBoundaryElements);
   real[int] uarr(nBoundaryElements);
   real[int] varr(nBoundaryElements);

   int ii=0;
   int1d(Th,qfe=qf1pE)(1.*(xarr[ii++]=x));
   ii=0;
   int1d(Th,qfe=qf1pE)(1.*(yarr[ii++]=y));
   ii=0;
   int1d(Th,qfe=qf1pE)(1.*(uarr[ii++]=u));
   ii=0;
   int1d(Th,qfe=qf1pE)(1.*(varr[ii++]=v));

   real A0 = int2d(Th)(1.0);
   real cmx= int2d(Th)(x);
   cmx = cmx/A0;
   real cmy= int2d(Th)(y);
   cmy = cmy/A0;


   ofstream printbound(fname,append);

   for(ii=0;ii<nBoundaryElements;ii++) {
      printbound << (xarr[ii]) << " " << (yarr[ii]) << " " << uarr[ii]
      << " " << varr[ii] << " " << cmx << " " << cmy << endl;
   }
   printbound << (xarr[0]) << " " << (yarr[0]) << " " << uarr[0] << " "
   << varr[0] << " " << cmx << " " << cmy << endl;
   printbound << endl;

}


//func int printData(string fname,real[int] x, real[int] y, real[int] ux, real[int] uy) 
//{
//   //ofstream printdataout(fname,append); 
//   //int i;
//   //for(i = 0; i < x.n;i++) {
//   //   printdataout << x[i] << " " << y[i] << " " << ux[i] << " " << uy[i] << endl;  
//   //}
//   //i=0;
//   //printdataout << x[i] << " " << y[i] << " " << ux[i] << " " << uy[i] << endl;  
//   //printdataout << endl;
//}

